<?php
require_once(__DIR__."/../db/connection.php");

function get_user_info($id_user) {
    global $mysqli;
    $return = array();
    $query = "SELECT u.*,p.name as plan FROM svt_users as u LEFT JOIN svt_plans as p ON p.id=u.id_plan WHERE u.id = $id_user LIMIT 1;";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows==1) {
            $row=$result->fetch_array(MYSQLI_ASSOC);
            if($row['expire_plan_date']==null) {
                $row['plan_status']='active';
            } else {
                if (new DateTime() > new DateTime($row['expire_plan_date'])) {
                    $row['plan_status']='expired';
                } else{
                    $row['plan_status']='active';
                }
            }
            $return=$row;
        }
    }
    return $return;
}

function get_user_role($id_user) {
    global $mysqli;
    $return = 'user';
    $query = "SELECT role FROM svt_users WHERE id = $id_user LIMIT 1;";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows==1) {
            $row=$result->fetch_array(MYSQLI_ASSOC);
            $return=$row['role'];
        }
    }
    return $return;
}

function get_virtual_tour($id_virtual_tour,$id_user) {
    global $mysqli;
    $return = array();
    $query = "SELECT * FROM svt_virtualtours WHERE id = $id_virtual_tour LIMIT 1;";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows==1) {
            $row=$result->fetch_array(MYSQLI_ASSOC);
            $id_user_vt = $row['id_user'];
            switch(get_user_role($id_user)) {
                case 'administrator';
                    break;
                case 'customer':
                    if($id_user!=$id_user_vt) return false;
                    break;
                case 'editor':
                    $query = "SELECT * FROM svt_assign_virtualtours WHERE id_user=$id_user AND id_virtualtour=$id_virtual_tour;";
                    $result = $mysqli->query($query);
                    if($result) {
                        if($result->num_rows==0) {
                            return false;
                        }
                    }
                    break;
            }
            $return=$row;
        }
    }
    return $return;
}

function get_virtual_tours($id_user) {
    global $mysqli;
    $return = array();
    switch(get_user_role($id_user)) {
        case 'administrator':
            $where = "";
            break;
        case 'customer':
            $where = " WHERE v.id_user=$id_user ";
            break;
        case 'editor':
            $where = " WHERE v.id IN () ";
            $query = "SELECT GROUP_CONCAT(id_virtualtour) as ids FROM svt_assign_virtualtours WHERE id_user=$id_user;";
            $result = $mysqli->query($query);
            if($result) {
                if($result->num_rows==1) {
                    $row=$result->fetch_array(MYSQLI_ASSOC);
                    $ids = $row['ids'];
                    $where = " WHERE v.id IN ($ids) ";
                }
            }
            break;
    }
    $query = "SELECT * FROM svt_virtualtours as v $where ORDER BY date_created DESC;";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows>0) {
            while($row=$result->fetch_array(MYSQLI_ASSOC)) {
                $return[]=$row;
            }
        }
    }
    return $return;
}

function get_virtual_tours_options_css() {
    global $mysqli;
    $return = "";
    $query = "SELECT code,name FROM svt_virtualtours ORDER BY name ASC;";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows>0) {
            while($row=$result->fetch_array(MYSQLI_ASSOC)) {
                $code = $row['code'];
                $name = $row['name'];
                $return .= "<option id='css_custom_$code'>$name</option>";
            }
        }
    }
    return $return;
}

function get_virtual_tours_editors_css() {
    global $mysqli;
    $return = "";
    $query = "SELECT code FROM svt_virtualtours;";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows>0) {
            while($row=$result->fetch_array(MYSQLI_ASSOC)) {
                $code = $row['code'];
                $return .= '<div style="display:none;position: relative;width: 100%;height: 400px;" class="editors_css" id="custom_'.$code.'">'.get_editor_css_content('custom_'.$code).'</div>';
            }
        }
    }
    return $return;
}

function get_editor_css_content($css) {
    $url_css = __DIR__.DIRECTORY_SEPARATOR.'..'.DIRECTORY_SEPARATOR.'viewer'.DIRECTORY_SEPARATOR.'css'.DIRECTORY_SEPARATOR.$css.'.css';
    if(file_exists($url_css)) {
        return @file_get_contents($url_css);
    } else {
        return '';
    }
}

function get_room($id_room,$id_user) {
    global $mysqli;
    $return = array();
    $query = "SELECT r.*,v.id_user,m.map,m.point_size,m.north_degree,v.id as id_virtualtour,v.enable_multires FROM svt_rooms as r
            JOIN svt_virtualtours as v ON r.id_virtualtour=v.id
            LEFT JOIN svt_maps as m ON m.id=r.id_map
            WHERE r.id = $id_room LIMIT 1;";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows==1) {
            $row=$result->fetch_array(MYSQLI_ASSOC);
            $id_user_vt = $row['id_user'];
            $id_virtual_tour = $row['id_virtualtour'];
            switch(get_user_role($id_user)) {
                case 'administrator';
                    break;
                case 'customer':
                    if($id_user!=$id_user_vt) return false;
                    break;
                case 'editor':
                    $query = "SELECT * FROM svt_assign_virtualtours WHERE id_user=$id_user AND id_virtualtour=$id_virtual_tour;";
                    $result = $mysqli->query($query);
                    if($result) {
                        if($result->num_rows==0) {
                            return false;
                        }
                    }
                    break;
            }
            if($row['enable_multires']) {
                $room_pano = str_replace('.jpg','',$row['panorama_image']);
                $multires_config_file = __DIR__.DIRECTORY_SEPARATOR.'..'.DIRECTORY_SEPARATOR.'viewer'.DIRECTORY_SEPARATOR.'panoramas'.DIRECTORY_SEPARATOR.'multires'.DIRECTORY_SEPARATOR.$room_pano.DIRECTORY_SEPARATOR.'config.json';
                if(file_exists($multires_config_file)) {
                    $multires_tmp = file_get_contents($multires_config_file);
                    $multires_array = json_decode($multires_tmp,true);
                    $multires_config = $multires_array['multiRes'];
                    $multires_config['basePath'] = '../viewer/panoramas/multires/'.$room_pano;
                    $row['multires']=1;
                    $row['multires_config']=json_encode($multires_config);
                    $row['multires_dir']='../viewer/panoramas/multires/'.$room_pano;
                } else {
                    $row['multires']=0;
                    $row['multires_config']='';
                    $row['multires_dir']='';
                }
            } else {
                $row['multires']=0;
                $row['multires_config']='';
                $row['multires_dir']='';
            }
            $return=$row;
        }
    }
    return $return;
}

function get_map($id_map,$id_user) {
    global $mysqli;
    $return = array();
    $query = "SELECT m.*,v.id_user,v.id as id_virtualtour FROM svt_maps as m
            JOIN svt_virtualtours as v ON m.id_virtualtour=v.id
            WHERE m.id = $id_map LIMIT 1;";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows==1) {
            $row=$result->fetch_array(MYSQLI_ASSOC);
            $id_user_vt = $row['id_user'];
            $id_virtual_tour = $row['id_virtualtour'];
            switch(get_user_role($id_user)) {
                case 'administrator';
                    break;
                case 'customer':
                    if($id_user!=$id_user_vt) return false;
                    break;
                case 'editor':
                    $query = "SELECT * FROM svt_assign_virtualtours WHERE id_user=$id_user AND id_virtualtour=$id_virtual_tour;";
                    $result = $mysqli->query($query);
                    if($result) {
                        if($result->num_rows==0) {
                            return false;
                        }
                    }
                    break;
            }
            $return=$row;
        }
    }
    return $return;
}

function get_rooms_option($id_virtualtour) {
    global $mysqli;
    $options = "";
    $query = "SELECT id,name FROM svt_rooms WHERE id_virtualtour=$id_virtualtour;";
    $result = $mysqli->query($query);
    if($result) {
        while($row=$result->fetch_array(MYSQLI_ASSOC)) {
            $id = $row['id'];
            $name = $row['name'];
            $options .= "<option id='$id'>$name</option>";
        }
    }
    return $options;
}

function get_plans_options($id_plan_sel) {
    global $mysqli;
    if($id_plan_sel==0) {
        $options = "<option selected id='0'>None</option>";
    } else {
        $options = "<option id='0'>None</option>";
    }
    $query = "SELECT * FROM svt_plans;";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows>0) {
            while($row=$result->fetch_array(MYSQLI_ASSOC)) {
                $id = $row['id'];
                $name = $row['name'];
                if($id_plan_sel==$id) {
                    $options .= "<option selected id='$id'>$name</option>";
                } else {
                    $options .= "<option id='$id'>$name</option>";
                }
            }
        }
    }
    return $options;
}

function get_plans($id_user) {
    global $mysqli;
    $return = array();
    $query = "SELECT * FROM svt_plans ORDER BY price ASC;";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows>0) {
            while($row=$result->fetch_array(MYSQLI_ASSOC)) {
                $return[] = $row;
            }
        }
    }
    return $return;
}

function check_plan($object,$id_user) {
    global $mysqli;
    switch($object) {
        case 'virtual_tour':
            $count_virtual_tours = 0;
            $plan_virtual_tours = -1;
            $query = "SELECT COUNT(*) as num FROM svt_virtualtours WHERE id_user = $id_user LIMIT 1;";
            $result = $mysqli->query($query);
            if($result) {
                if($result->num_rows==1) {
                    $row=$result->fetch_array(MYSQLI_ASSOC);
                    $count_virtual_tours = $row['num'];
                }
            }
            $query = "SELECT n_virtual_tours FROM svt_plans as p LEFT JOIN svt_users AS u ON u.id_plan=p.id WHERE u.id = $id_user LIMIT 1;";
            $result = $mysqli->query($query);
            if($result) {
                if($result->num_rows==1) {
                    $row=$result->fetch_array(MYSQLI_ASSOC);
                    $plan_virtual_tours = $row['n_virtual_tours'];
                }
            }
            $can_create = false;
            if($plan_virtual_tours<0) {
                $can_create = true;
            } else {
                if($count_virtual_tours>=$plan_virtual_tours) {
                    $can_create = false;
                } else {
                    $can_create = true;
                }
            }
            return $can_create;
            break;
        case 'room':
            $count_rooms = 0;
            $plan_rooms = -1;
            $query = "SELECT COUNT(*) as num FROM svt_rooms as r
                        JOIN svt_virtualtours as v ON v.id = r.id_virtualtour
                        WHERE id_user = $id_user LIMIT 1;";
            $result = $mysqli->query($query);
            if($result) {
                if($result->num_rows==1) {
                    $row=$result->fetch_array(MYSQLI_ASSOC);
                    $count_rooms = $row['num'];
                }
            }
            $query = "SELECT n_rooms FROM svt_plans as p LEFT JOIN svt_users AS u ON u.id_plan=p.id WHERE u.id = $id_user LIMIT 1;";
            $result = $mysqli->query($query);
            if($result) {
                if($result->num_rows==1) {
                    $row=$result->fetch_array(MYSQLI_ASSOC);
                    $plan_rooms = $row['n_rooms'];
                }
            }
            $can_create = false;
            if($plan_rooms<0) {
                $can_create = true;
            } else {
                if($count_rooms>=$plan_rooms) {
                    $can_create = false;
                } else {
                    $can_create = true;
                }
            }
            return $can_create;
            break;
        case 'marker':
            $count_markers = 0;
            $plan_markers = -1;
            $query = "SELECT COUNT(*) as num FROM svt_markers as m
                        JOIN svt_rooms as r ON m.id_room = r.id
                        JOIN svt_virtualtours as v ON v.id = r.id_virtualtour
                        WHERE id_user = $id_user LIMIT 1;";
            $result = $mysqli->query($query);
            if($result) {
                if($result->num_rows==1) {
                    $row=$result->fetch_array(MYSQLI_ASSOC);
                    $count_markers = $row['num'];
                }
            }
            $query = "SELECT n_markers FROM svt_plans as p LEFT JOIN svt_users AS u ON u.id_plan=p.id WHERE u.id = $id_user LIMIT 1;";
            $result = $mysqli->query($query);
            if($result) {
                if($result->num_rows==1) {
                    $row=$result->fetch_array(MYSQLI_ASSOC);
                    $plan_markers = $row['n_markers'];
                }
            }
            $can_create = false;
            if($plan_markers<0) {
                $can_create = true;
            } else {
                if($count_markers>=$plan_markers) {
                    $can_create = false;
                } else {
                    $can_create = true;
                }
            }
            return $can_create;
            break;
        case 'poi':
            $count_pois = 0;
            $plan_pois = -1;
            $query = "SELECT COUNT(*) as num FROM svt_pois as m
                        JOIN svt_rooms as r ON m.id_room = r.id
                        JOIN svt_virtualtours as v ON v.id = r.id_virtualtour
                        WHERE id_user = $id_user LIMIT 1;";
            $result = $mysqli->query($query);
            if($result) {
                if($result->num_rows==1) {
                    $row=$result->fetch_array(MYSQLI_ASSOC);
                    $count_pois = $row['num'];
                }
            }
            $query = "SELECT n_pois FROM svt_plans as p LEFT JOIN svt_users AS u ON u.id_plan=p.id WHERE u.id = $id_user LIMIT 1;";
            $result = $mysqli->query($query);
            if($result) {
                if($result->num_rows==1) {
                    $row=$result->fetch_array(MYSQLI_ASSOC);
                    $plan_pois = $row['n_pois'];
                }
            }
            $can_create = false;
            if($plan_pois<0) {
                $can_create = true;
            } else {
                if($count_pois>=$plan_pois) {
                    $can_create = false;
                } else {
                    $can_create = true;
                }
            }
            return $can_create;
            break;
        case 'landing':
            $can_create = false;
            $query = "SELECT create_landing FROM svt_plans as p LEFT JOIN svt_users AS u ON u.id_plan=p.id WHERE u.id = $id_user LIMIT 1;";
            $result = $mysqli->query($query);
            if($result) {
                if($result->num_rows==1) {
                    $row=$result->fetch_array(MYSQLI_ASSOC);
                    $create_landing = $row['create_landing'];
                    if($create_landing==1) $can_create=true;
                }
            }
            return $can_create;
            break;
        case 'gallery':
            $can_create = false;
            $query = "SELECT create_gallery FROM svt_plans as p LEFT JOIN svt_users AS u ON u.id_plan=p.id WHERE u.id = $id_user LIMIT 1;";
            $result = $mysqli->query($query);
            if($result) {
                if($result->num_rows==1) {
                    $row=$result->fetch_array(MYSQLI_ASSOC);
                    $create_gallery = $row['create_gallery'];
                    if($create_gallery==1) $can_create=true;
                }
            }
            return $can_create;
            break;
        case 'presentation':
            $can_create = false;
            $query = "SELECT create_presentation FROM svt_plans as p LEFT JOIN svt_users AS u ON u.id_plan=p.id WHERE u.id = $id_user LIMIT 1;";
            $result = $mysqli->query($query);
            if($result) {
                if($result->num_rows==1) {
                    $row=$result->fetch_array(MYSQLI_ASSOC);
                    $create_presentation = $row['create_presentation'];
                    if($create_presentation==1) $can_create=true;
                }
            }
            return $can_create;
            break;
        default:
            return false;
            break;
    }
}

function check_plan_rooms_count($id_user) {
    global $mysqli;
    $rooms_count_create = 0;
    $count_rooms = 0;
    $plan_rooms = -1;
    $query = "SELECT COUNT(*) as num FROM svt_rooms as r
                        JOIN svt_virtualtours as v ON v.id = r.id_virtualtour
                        WHERE id_user = $id_user LIMIT 1;";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows==1) {
            $row=$result->fetch_array(MYSQLI_ASSOC);
            $count_rooms = $row['num'];
        }
    }
    $query = "SELECT n_rooms FROM svt_plans as p LEFT JOIN svt_users AS u ON u.id_plan=p.id WHERE u.id = $id_user LIMIT 1;";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows==1) {
            $row=$result->fetch_array(MYSQLI_ASSOC);
            $plan_rooms = $row['n_rooms'];
        }
    }
    if($plan_rooms<0) {
        $rooms_count_create = -1;
    } else {
        $rooms_count_create = $plan_rooms-$count_rooms;
    }
    return $rooms_count_create;
}

function get_voice_commands() {
    global $mysqli;
    $return = array();
    $query = "SELECT * FROM svt_voice_commands LIMIT 1;";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows==1) {
            $row=$result->fetch_array(MYSQLI_ASSOC);
            $return=$row;
        }
    }
    return $return;
}

function get_settings() {
    global $mysqli;
    $return = array();
    $query = "SELECT * FROM svt_settings LIMIT 1;";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows==1) {
            $row=$result->fetch_array(MYSQLI_ASSOC);
            if(empty($row['contact_email'])) {
                $query_ce = "SELECT email FROM svt_users WHERE role='administrator' LIMIT 1;";
                $result_ce = $mysqli->query($query_ce);
                if($result_ce) {
                    if ($result_ce->num_rows == 1) {
                        $row_ce = $result_ce->fetch_array(MYSQLI_ASSOC);
                        $row['contact_email'] = $row_ce['email'];
                    }
                }
            }
            $return=$row;
        }
    }
    return $return;
}

function get_library_icons($id_virtualtour,$p) {
    global $mysqli;
    $return = "";
    $query = "SELECT * FROM svt_icons WHERE id_virtualtour=$id_virtualtour;";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows>0) {
            while($row=$result->fetch_array(MYSQLI_ASSOC)) {
                $id = $row['id'];
                $image = $row['image'];
                $return .= "<img onclick='select_icon_library(\"$p\",$id,\"$image\");' style='display: inline-block;width:50px;padding: 3px;' src='../viewer/icons/$image' />";
            }
        } else {
            $return = "No icons in that library.";
        }
    }
    return $return;
}

function get_option_exist_logo($id_user) {
    global $mysqli;
    $return = "";
    $query = "SELECT DISTINCT logo FROM svt_virtualtours WHERE id_user=$id_user AND logo!='';";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows>0) {
            while($row=$result->fetch_array(MYSQLI_ASSOC)) {
                $logo = $row['logo'];
                $return .= "<option id='$logo'>$logo</option>";
            }
        }
    }
    return $return;
}

function get_option_exist_nadir_logo($id_user) {
    global $mysqli;
    $return = "";
    $query = "SELECT DISTINCT nadir_logo FROM svt_virtualtours WHERE id_user=$id_user AND nadir_logo!='';";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows>0) {
            while($row=$result->fetch_array(MYSQLI_ASSOC)) {
                $nadir_logo = $row['nadir_logo'];
                $return .= "<option id='$nadir_logo'>$nadir_logo</option>";
            }
        }
    }
    return $return;
}

function get_option_exist_background_logo($id_user) {
    global $mysqli;
    $return = "";
    $query = "SELECT DISTINCT background_image FROM svt_virtualtours WHERE id_user=$id_user AND background_image!='';";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows>0) {
            while($row=$result->fetch_array(MYSQLI_ASSOC)) {
                $background_image = $row['background_image'];
                $return .= "<option id='$background_image'>$background_image</option>";
            }
        }
    }
    return $return;
}

function get_option_exist_song($id_user) {
    global $mysqli;
    $return = "";
    $query = "SELECT DISTINCT song FROM svt_virtualtours WHERE id_user=$id_user AND song!='';";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows>0) {
            while($row=$result->fetch_array(MYSQLI_ASSOC)) {
                $song = $row['song'];
                $return .= "<option id='$song'>$song</option>";
            }
        }
    }
    return $return;
}

function get_option_exist_introd($id_user) {
    global $mysqli;
    $return = "";
    $query = "SELECT DISTINCT intro_desktop FROM svt_virtualtours WHERE id_user=$id_user AND intro_desktop!='';";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows>0) {
            while($row=$result->fetch_array(MYSQLI_ASSOC)) {
                $intro_desktop = $row['intro_desktop'];
                $return .= "<option id='$intro_desktop'>$intro_desktop</option>";
            }
        }
    }
    return $return;
}

function get_option_exist_introm($id_user) {
    global $mysqli;
    $return = "";
    $query = "SELECT DISTINCT intro_mobile FROM svt_virtualtours WHERE id_user=$id_user AND intro_mobile!='';";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows>0) {
            while($row=$result->fetch_array(MYSQLI_ASSOC)) {
                $intro_mobile = $row['intro_mobile'];
                $return .= "<option id='$intro_mobile'>$intro_mobile</option>";
            }
        }
    }
    return $return;
}

function generateRandomString($length = 10) {
    $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
    $charactersLength = strlen($characters);
    $randomString = '';
    for ($i = 0; $i < $length; $i++) {
        $randomString .= $characters[rand(0, $charactersLength - 1)];
    }
    return $randomString;
}

function update_plans_expires_date() {
    global $mysqli;
    $query = "SELECT u.id,u.registration_date,p.days,u.role FROM svt_users as u
                JOIN svt_plans as p ON p.id=u.id_plan";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows>0) {
            while($row=$result->fetch_array(MYSQLI_ASSOC)) {
                $id_user = $row['id'];
                $reg_date = $row['registration_date'];
                $days = $row['days'];
                $role = $row['role'];
                switch($role) {
                    case 'administrator':
                    case 'editor':
                        $mysqli->query("UPDATE svt_users SET expire_plan_date=NULL WHERE id=$id_user;");
                        break;
                    case 'customer':
                        if($days<0) {
                            $mysqli->query("UPDATE svt_users SET expire_plan_date=NULL WHERE id=$id_user;");
                        } else {
                            $exp_date = date('Y-m-d H:i:s', strtotime($reg_date. " + $days days"));
                            $mysqli->query("UPDATE svt_users SET expire_plan_date='$exp_date' WHERE id=$id_user;");
                        }
                        break;
                }
            }
        }
    }
}

function get_user_stats($id_user) {
    global $mysqli;
    $stats = array();
    $stats['count_virtual_tours'] = 0;
    $stats['count_rooms'] = 0;
    $stats['count_markers'] = 0;
    $stats['count_pois'] = 0;
    $query = "SELECT COUNT(*) as num FROM svt_virtualtours WHERE id_user = $id_user LIMIT 1";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows==1) {
            $row=$result->fetch_array(MYSQLI_ASSOC);
            $num = $row['num'];
            $stats['count_virtual_tours'] = $num;
        }
    }
    $query = "SELECT COUNT(*) as num FROM svt_rooms as r
                JOIN svt_virtualtours as v ON v.id = r.id_virtualtour
                WHERE id_user = $id_user LIMIT 1;";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows==1) {
            $row=$result->fetch_array(MYSQLI_ASSOC);
            $num = $row['num'];
            $stats['count_rooms'] = $num;
        }
    }
    $query = "SELECT COUNT(*) as num FROM svt_markers as m
                JOIN svt_rooms as r ON m.id_room = r.id
                JOIN svt_virtualtours as v ON v.id = r.id_virtualtour
                WHERE id_user = $id_user LIMIT 1;";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows==1) {
            $row=$result->fetch_array(MYSQLI_ASSOC);
            $num = $row['num'];
            $stats['count_markers'] = $num;
        }
    }
    $query = "SELECT COUNT(*) as num FROM svt_pois as m
                JOIN svt_rooms as r ON m.id_room = r.id
                JOIN svt_virtualtours as v ON v.id = r.id_virtualtour
                WHERE id_user = $id_user LIMIT 1;";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows==1) {
            $row=$result->fetch_array(MYSQLI_ASSOC);
            $num = $row['num'];
            $stats['count_pois'] = $num;
        }
    }
    return $stats;
}

function get_plan($id) {
    global $mysqli;
    $return = array();
    $query = "SELECT * FROM svt_plans WHERE id=$id LIMIT 1;";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows==1) {
            $row=$result->fetch_array(MYSQLI_ASSOC);
            $return=$row;
        }
    }
    return $return;
}

function get_next_prev_room_id($id_room,$id_virtualtour) {
    global $mysqli;
    $array_rooms = array();
    $query = "SELECT id FROM svt_rooms WHERE id_virtualtour=$id_virtualtour ORDER BY priority;";
    $result = $mysqli->query($query);
    if($result) {
        while($row=$result->fetch_array(MYSQLI_ASSOC)) {
            $id = $row['id'];
            array_push($array_rooms,$id);
        }
    }
    $index = array_search($id_room,$array_rooms);
    $len = count($array_rooms);
    $prev_id = $array_rooms[($index+$len-1)%$len];
    $next_id = $array_rooms[($index+1)%$len];
    return [$next_id,$prev_id];
}

function get_assign_virtualtours($id_user) {
    global $mysqli;
    $return = "";
    $query = "SELECT id,name FROM svt_virtualtours ORDER BY name;";
    $result = $mysqli->query($query);
    if($result) {
        if($result->num_rows>0) {
            while($row=$result->fetch_array(MYSQLI_ASSOC)) {
                $id = $row['id'];
                $name = $row['name'];
                $query_c = "SELECT * FROM svt_assign_virtualtours WHERE id_user=$id_user AND id_virtualtour=$id LIMIT 1";
                $result_c = $mysqli->query($query_c);
                if($result_c) {
                    if ($result_c->num_rows == 1) {
                        $return .= "<div class='col-md-4 mb-2'><label><input id='$id' checked type='checkbox'> $name</label></div>";
                    } else {
                        $return .= "<div class='col-md-4 mb-2'><label><input id='$id' type='checkbox'> $name</label></div>";
                    }
                }
            }
        }
    }
    return $return;
}

function generate_multires($force_update,$id_virtualtour) {
    try {
        $command = 'command -v php 2>&1';
        $output = shell_exec($command);
        if($output!="") {
            $path_php = trim($output);
            $path = realpath(dirname(__FILE__) . '/..');
            if($force_update) {
                $command = $path_php." ".$path.DIRECTORY_SEPARATOR."services".DIRECTORY_SEPARATOR."generate_multires.php 1 $id_virtualtour > /dev/null &";
            } else {
                $command = $path_php." ".$path.DIRECTORY_SEPARATOR."services".DIRECTORY_SEPARATOR."generate_multires.php > /dev/null &";
            }
            shell_exec($command);
        }
    } catch (Exception $e) {}
}

function set_language($language,$domain) {
    if(defined('LC_MESSAGES')) {
        setlocale(LC_MESSAGES, $language);
    } else {
        putenv('LC_ALL='.$language);
    }
    bindtextdomain($domain, "../locale");
    bind_textdomain_codeset($domain, 'UTF-8');
    textdomain($domain);
}

function dateDiffInDays($date1, $date2) {
    $diff = strtotime($date2) - strtotime($date1);
    return abs(round($diff / 86400));
}

function _GetMaxAllowedUploadSize(){
    $Sizes = array();
    $Sizes[] = ini_get('upload_max_filesize');
    $Sizes[] = ini_get('post_max_size');
    $Sizes[] = ini_get('memory_limit');
    for($x=0;$x<count($Sizes);$x++){
        $Last = strtolower($Sizes[$x][strlen($Sizes[$x])-1]);
        if($Last == 'k'){
            $Sizes[$x] *= 1024;
        } elseif($Last == 'm'){
            $Sizes[$x] *= 1024;
            $Sizes[$x] *= 1024;
        } elseif($Last == 'g'){
            $Sizes[$x] *= 1024;
            $Sizes[$x] *= 1024;
            $Sizes[$x] *= 1024;
        } elseif($Last == 't'){
            $Sizes[$x] *= 1024;
            $Sizes[$x] *= 1024;
            $Sizes[$x] *= 1024;
            $Sizes[$x] *= 1024;
        }
    }
    return _Byte2Size(min($Sizes));
}

function _Byte2Size($bytes,$RoundLength=1) {
    $kb = 1024;         // Kilobyte
    $mb = 1024 * $kb;   // Megabyte
    $gb = 1024 * $mb;   // Gigabyte
    $tb = 1024 * $gb;   // Terabyte
    if($bytes < $kb) {
        if(!$bytes){
            $bytes = '0';
        }
        return (($bytes + 1)-1).' B';
    } else if($bytes < $mb) {
        return round($bytes/$kb,$RoundLength).' KB';
    } else if($bytes < $gb) {
        return round($bytes/$mb,$RoundLength).' MB';
    } else if($bytes < $tb) {
        return round($bytes/$gb,$RoundLength).' GB';
    } else {
        return round($bytes/$tb,$RoundLength).' TB';
    }
}
