<?php
error_reporting(E_ALL & ~E_WARNING & ~E_NOTICE & ~E_DEPRECATED);
if(!file_exists("../config/config.inc.php")) {
    header("Location: ../install/start.php");
}
require_once("functions.php");
$settings = get_settings();
if($settings['enable_registration']==0) {
    die("Registration closed");
}
set_language($settings['language'],$settings['language_domain']);
?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta http-equiv="content-type" content="text/html;charset=UTF-8" />
    <meta charset="UTF-8">
    <meta name="description" content="">
    <meta name="author" content="">
    <title><?php echo $settings['name']; ?></title>
    <link rel="apple-touch-icon" sizes="180x180" href="favicons/apple-touch-icon.png">
    <link rel="icon" type="image/png" sizes="32x32" href="favicons/favicon-32x32.png">
    <link rel="icon" type="image/png" sizes="16x16" href="favicons/favicon-16x16.png">
    <link rel="manifest" href="favicons/site.webmanifest">
    <link rel="mask-icon" href="favicons/safari-pinned-tab.svg" color="#5bbad5">
    <link rel="shortcut icon" href="favicons/favicon.ico">
    <meta name="msapplication-TileColor" content="#da532c">
    <meta name="msapplication-config" content="favicons/browserconfig.xml">
    <meta name="theme-color" content="#ffffff">
    <link href="../viewer/vendor/fontawesome-free/css/all.min.css" rel="stylesheet" type="text/css">
    <link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">
    <link href="css/sb-admin-2.min.css" rel="stylesheet">
    <link href="css/custom.css" rel="stylesheet">
</head>

<body class="bg-gradient-primary">
<div class="container">
    <div class="row">
        <?php if($settings['logo']!='') : ?>
            <div class="col-md-12 text-white mt-4 text-center">
                <img style="max-height:100px;max-width:200px;width:auto;height:auto" src="assets/<?php echo $settings['logo']; ?>" />
            </div>
        <?php endif; ?>
    </div>
    <div class="row justify-content-center">
        <div class="col-xl-10 col-lg-12 col-md-9">
            <div class="card o-hidden border-0 shadow-lg my-5">
                <div class="card-body p-0">
                    <div class="row">
                        <div style="<?php echo ($settings['background']!='') ? 'background-image: url(assets/'.$settings['background'].');'  : '' ; ?>" class="col-lg-6 d-none d-lg-block bg-login-image"></div>
                        <div class="col-lg-6">
                            <div class="p-5">
                                <div class="text-center">
                                    <h1 class="h4 text-gray-900 mb-4"><?php echo _("Create an Account!"); ?></h1>
                                </div>
                                <form class="user user_register" method="post" action="#">
                                    <div class="form-group row">
                                        <div class="col-sm-12">
                                            <input autocomplete="new-password" type="text" class="form-control form-control-user" id="username_r" placeholder="<?php echo _("User name"); ?>">
                                        </div>
                                    </div>
                                    <div class="form-group">
                                        <input autocomplete="new-password" type="email" class="form-control form-control-user" id="email_r" placeholder="<?php echo _("Email Address"); ?>">
                                    </div>
                                    <div class="form-group row">
                                        <div class="col-sm-6 mb-3 mb-sm-0">
                                            <input autocomplete="new-password" type="password" class="form-control form-control-user" id="password_r" placeholder="<?php echo _("Password"); ?>">
                                        </div>
                                        <div class="col-sm-6">
                                            <input autocomplete="new-password" type="password" class="form-control form-control-user" id="password2_r" placeholder="<?php echo _("Repeat Password"); ?>">
                                        </div>
                                    </div>
                                    <button id="btn_register" type="submit" class="btn btn-primary btn-user btn-block">
                                        <?php echo _("Register Account"); ?>
                                    </button>
                                    <hr>
                                    <div class="text-center">
                                        <a class="small" href="login.php"><?php echo _("Already have an account? Login!"); ?></a>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-md-12 text-white mt-0 text-center">
            <h2><?php echo strtoupper($settings['name']); ?></h2>
        </div>
    </div>
</div>

<script src="vendor/jquery/jquery.min.js"></script>
<script src="vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="vendor/jquery-easing/jquery.easing.min.js"></script>
<script src="js/sb-admin-2.js"></script>
<script>
    window.register_labels = {
        "error_msg":"<?php echo _("Error, retry later."); ?>",
    };
</script>
<script src="js/function.js?v=<?php echo time(); ?>"></script>

<script>
    $(".user_register").submit(function(e){
        register();
        e.preventDefault();
    });
</script>

</body>
</html>
